package de.twomartens.oparlservice.entity;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.*;
import lombok.experimental.SuperBuilder;

import java.util.List;

@SuperBuilder
@Getter
@ToString
@EqualsAndHashCode(callSuper = true)
@AllArgsConstructor(access = AccessLevel.PRIVATE)
@NoArgsConstructor(force = true, access = AccessLevel.PRIVATE)
@Schema(allOf = CommonFields.class)
public class Location extends CommonFields {

    @Schema(description = "description of the location", nullable = true)
    private final String description;

    @Schema(description = "GeoJSON object of the location", nullable = true)
    private final Object geojson;

    @Schema(description = "street address of the location", nullable = true)
    private final String streetAddress;

    @Schema(description = "room information of the location", nullable = true)
    private final String room;

    @Schema(description = "postal code of the location", nullable = true)
    private final String postalCode;

    @Schema(description = "lower rank locality of the location", nullable = true)
    private final String subLocality;

    @Schema(description = "locality of the location", nullable = true)
    private final String locality;

    @Schema(description = "List of URLS to bodies this location is used for", nullable = true)
    private final List<String> bodies;

    @Schema(description = "List of URLS to organizations this location is used for", nullable = true)
    private final List<String> organizations;

    @Schema(description = "List of URLS to persons this location is used for", nullable = true)
    private final List<String> persons;

    @Schema(description = "List of URLS to meetings this location is used for", nullable = true)
    private final List<String> meetings;

    @Schema(description = "List of URLS to papers this location is used for", nullable = true)
    private final List<String> papers;
}
